ball = class{function(self, x,y,radius)
	self.force=10
	self.mass=10
	self.radius=radius or 10
	y=y-self.radius
	self.body=love.physics.newBody(world.physicsWorld, x, y,'dynamic')
   local s= love.physics.newCircleShape(0, 0, self.radius)
   self.fixture= love.physics.newFixture(self.body,s, 1)
	self.shape=self.fixture:getShape()
	self.body:setMass(self.mass)
	self.body:setLinearDamping(0.6) --simulate air resistance / get the ball to actually stop
	self.fixture:setRestitution (0.7) --Bounciness of surface (1 means it bounces to original height)
	self.fixture:setFriction (0.6)

end}

function ball:draw()
		love.graphics.setColor(255,255,255)
		love.graphics.setLine(4, 'rough')
		local x,y=self:getPosition()
		love.graphics.circle('line',x,y,self.radius)
end

function ball:getPosition()
	return self.body:getPosition()
end

function ball:launch()
	if not self.launched then
		self.launched=true
		local x,y=self:getPosition()
		self.body:applyLinearImpulse((love.mouse.getX()-x)*self.force,(love.mouse.getY()-y)*self.force)

	end
end

function ball:getDistance()
	local distance=math.floor(ball:getPosition())
	return distance
end

function ball:isStopped()
	return not self.body:isAwake() and self.launched
end

