enemy = class{function(self, x,y,width,height,health)
	table.insert(objects.enemies,self)
	self.mass=10
	self.health=health or 100

	local width=width or 50
	local height=height or 50
	y=y-height/2
	self.body=love.physics.newBody(world.physicsWorld, x, y,'dynamic')
   local s= love.physics.newRectangleShape(width,height)
   self.fixture= love.physics.newFixture(self.body,s, 1)
	self.shape=self.fixture:getShape()
	self.body:setMass(self.mass)
	self.body:setLinearDamping(0.6) --simulate air resistance / get the enemy to actually stop
	self.fixture:setRestitution (0.7) --Bounciness of surface (1 means it bounces to original height)
	self.fixture:setFriction (0.8)
	self.fixture:setUserData(self)
end}

function enemy:draw()
		love.graphics.setColor(255,255,255)
		love.graphics.setLine(4, 'rough')
		local x,y=self:getPosition()
		love.graphics.polygon('line',self.body:getWorldPoints(self.shape:getPoints()))
		love.graphics.print(self:getHealth(),x,y)
end

function enemy:getPosition()
	return self.body:getPosition()
end

function enemy:takeDamage(force)
	self.health=math.floor(self.health-force/10000)

end

function enemy:update()
	if self.health<0 then
		self:destroy()
	end
end

function enemy:getHealth()
	return self.health
end

function enemy:getDistance()
	local distance=math.floor(enemy:getPosition())
	return distance
end

function enemy:isStopped()
	return not self.body:isAwake() and self.launched
end

function enemy:destroy()
	self.body:destroy()
	deleteObject(objects.enemies,self)
end
