class=require 'hump.class'
require 'ball'
require 'enemy'
function love.load()
love.graphics.setColor(255,255,255)

	font = {}
	font.default = love.graphics.newFont(12)
	font.huuuge  = love.graphics.newFont(96)
	font.huuge = love.graphics.newFont(24)

	point = {}

	world = {}
	world.width   = love.graphics.getWidth()
	world.height  = love.graphics.getHeight()
	local gravityX=0
	local gravityY=200
	love.physics.setMeter(128)
	world.physicsWorld= love.physics.newWorld(gravityX,gravityY)
	world.physicsWorld:setCallbacks(beginContact, endContact, preSolve, postSolve)

	ground={}
	ground.body =    love.physics.newBody(world.physicsWorld,0,world.height)
   local s= love.physics.newEdgeShape(0, 0, 2000, 0)
   ground.fixture = love.physics.newFixture(ground.body,s,0)
	ground.shape=ground.fixture:getShape()
	ground.fixture:setRestitution (0.7) --Bounciness of surface (1 means it bounces to original height)
	ground.fixture:setFriction (0.8)

	ball =ball(15,world.height)

	objects={}
	objects.enemies={}
	enemy(world.width*0.5,world.height)

	love.graphics.setPoint(6, 'smooth')
end


function love.update(dt)
	world.physicsWorld:update(dt)
	for i,v in ipairs(objects.enemies) do
		v:update(dt)
	end
end

function love.mousepressed(x,y,b)
	if b=='l' then
		ball:launch(x,y)
	end
end



function love.draw()
	if ball:isStopped() then
		if #objects.enemies==0 then
			displayGameOver('You win!','You destroyed all the enemies')
		else
			displayGameOver('You lose!','You did not destroy all the enemies')
		end
	end
	love.graphics.print(ball:getDistance(),0,0) --prints meters
	ball:draw()
	for i,v in ipairs(objects.enemies) do
		v:draw()
	end
	love.graphics.line(0,world.height,world.width,world.height)
end

function beginContact(a, b, coll)
	local aBody=a:getBody()
	local bBody=b:getBody()
	local x1,y1=aBody:getLinearVelocity()
	local x2,y2=bBody:getLinearVelocity()
	local mass=aBody:getMass()
	if (x2^2+y2^2)>(x1^2+y1^2) then
		mass=bBody:getMass()
	end
	local force=((y2-y1)^2+(x2-x1)^2)*mass
	local aObject=a:getUserData()
	local bObject=b:getUserData()
	if type(aObject)=='table' then
		aObject:takeDamage(force)
	end
	if type(bObject)=='table' then
		bObject:takeDamage(force)
	end
end

function deleteObject(tab,obj)
    for i,v in ipairs(tab) do
        if v==obj then
            table.remove(tab,i)
            return
        end
    end
end

function displayGameOver(header,text)
	love.graphics.setFont(font.huuuge)
		love.graphics.printf(header,0,256,world.width,'center')
		love.graphics.setFont(font.default)
		love.graphics.printf(text,0,384,world.width,'center')
		love.graphics.setFont(font.default)
		love.graphics.setColor(128,128,128)
end
